/*
 Frequ systh forTracker HF radio.
 VK3ZYZ 20211208
 NOTE. The encoder needs to be changed to interupt driven. :)
 Fix unneeded LCD updates
 */

#define Version "Tracker20220106I"

#include "si5351.h"
#include "Wire.h"
//#include <LCD.h>  
#include <LiquidCrystal_I2C.h>

// synthesiser 3.5Mhz-3.9MHz (80m band)
unsigned long frequency =   3630000;         // 4 bytes required for frequency
unsigned long step_size =      1000;         // default tuning increment (Hz)
unsigned long old_step_size =     0; 
unsigned long offset    =   1647000;         // IF offset for clockgen
unsigned long USB       = 165000000;         // USB sideband mixer crystal
unsigned long LSB       = 164700000;         // LSB sideband mixer crystal                         
/*
unsigned long frequency0 =    00000;          // 4 bytes required for frequency
unsigned long frequency1 =  1810000;          // 4 bytes required for frequency
unsigned long frequency2 =  3525000;          // 4 bytes required for frequency 
unsigned long frequency3 =  5351000;          // 4 bytes required for frequency 
unsigned long frequency4 =  7000000;          // 4 bytes required for frequency
unsigned long frequency5 = 10100000;          // 4 bytes required for frequency
unsigned long frequency6 = 14100000;          // 4 bytes required for frequency
unsigned long frequency7 = 18068000;          // 4 bytes required for frequency
unsigned long frequency8 = 21000000;          // 4 bytes required for frequency
*/
unsigned long frequency0 =    00000;          // 4 bytes required for frequency
unsigned long frequency1 =  1810000;          // 4 bytes required for frequency
unsigned long frequency2 =  3525000;          // 4 bytes required for frequency 
unsigned long frequency3 =  3625000;          // 4 bytes required for frequency 
unsigned long frequency4 =  7000000;          // 4 bytes required for frequency
unsigned long frequency5 = 10120000;          // 4 bytes required for frequency
unsigned long frequency6 = 14100000;          // 4 bytes required for frequency
unsigned long frequency7 =    00000;          // 4 bytes required for frequency
unsigned long frequency8 =    00000;          // 4 bytes required for frequency

int temp = 0;  
static signed char ham_band_index = 0;
int32_t cal_factor = 27000; //  eg. 16360 for my board, found from Si5351 calibrator sketch.
  
long encoder;                                // encoder direction: CCW=-1; NC=0; CW=1
Si5351 clockgen;                             // instantiate clockgen


volatile int master_count = 0; // universal count
volatile byte INTFLAG1 = 0; // interrupt status flag

// encoder definitions
#define ENCODER_A      2
#define ENCODER_B      3
#define ENCODER_BUTTON 4

#define PTT            6
//Band Select Outputs
#define BandF1         7
#define BandF2         8
#define BandF3         9
#define BandF4        10

#define SSB_SWITCH    A2
#define Clarifier     A3
// A4 = SDA
// A5 = SCL
#define BAND_SWITCH   A6

                          
#define ENCODER_INPUT_PORT PIND
int sideband = 0;   
int last_sideband = 1;

LiquidCrystal_I2C  lcd(0x27,16,2); 


void setup() { 
  Serial.begin(115200);                 // set serial port speed
  lcd.init();                            // 16 char x 2 line LCD display
  lcd.backlight();
  lcd.print(Version);
  delay(1000);
  lcd.clear();
  
  bool i2c_found;

  // Start serial and initialize the Si5351
  Serial.begin(57600);
  i2c_found = clockgen.init(SI5351_CRYSTAL_LOAD_8PF, 0, 0);
  clockgen.set_correction(cal_factor, SI5351_PLL_INPUT_XO); // <<<<<<<this is found from Si5351 calibrator code.

  if(!i2c_found)
  {
    lcd.print("Device not found on I2C bus!");
  }
  
  // configure rotary encoder & push-button
  pinMode(ENCODER_A, INPUT_PULLUP);          // WIRE-OR encoder leads
  pinMode(ENCODER_B, INPUT_PULLUP);  
  pinMode(ENCODER_BUTTON, INPUT_PULLUP);
  pinMode(BAND_SWITCH, INPUT_PULLUP);
  pinMode(SSB_SWITCH, INPUT); // High = USB, LOW =  LSB

  pinMode(BandF1,OUTPUT); // 2.000 -  3.300Mhz
  pinMode(BandF2,OUTPUT); // 3.301 -  5.500Mhz
  pinMode(BandF3,OUTPUT); // 5.501 -  9.000Mhz
  pinMode(BandF4,OUTPUT); // 9.001 - 15.000Mhz

/*
       HF Bands              SSB part                      LPF band
 160M =  1.800 -  1.875 (1.840-1.875)                     ` 1 maybe ??????
  80M =  3.500 -  3.800 (3.535-3.620, 3.640-3.700)          2
  60M =  5.3515 – 5.3665 MHz
  40M =  7.000 -  7.300 ( 7.040-7.300)                      3
  20M = 14.000 - 14.350 (14.112-14.350)                     4
  
  17M = 18.068 - 18.168 (18.110-18.168)                     
  15M = 21.000 - 21.240 (21.150-21.450)                     
  12M = 24.890 - 24.990 (24.930-24.990)                     
  10M = 28.000 - 29.700 (28.300-29.100)   
  
 */
 // Active LOW to select BandFilter
  digitalWrite(BandF1,LOW);
  digitalWrite(BandF2,HIGH);
  digitalWrite(BandF3,HIGH);
  digitalWrite(BandF4,HIGH);
  delay(200);
  digitalWrite(BandF1,HIGH);
  digitalWrite(BandF2,LOW);
  digitalWrite(BandF3,HIGH);
  digitalWrite(BandF4,HIGH);
  delay(200);
  digitalWrite(BandF1,HIGH);
  digitalWrite(BandF2,HIGH);
  digitalWrite(BandF3,LOW);
  digitalWrite(BandF4,HIGH);
  delay(200);
  digitalWrite(BandF1,HIGH);
  digitalWrite(BandF2,HIGH);
  digitalWrite(BandF3,HIGH);
  digitalWrite(BandF4,LOW);
  delay(200);

  set_synth();
  display_freq_step();               // display frequency & step-size

  attachInterrupt(0, flag, RISING);  
  // interrupt 0 digital pin 2 positive edge trigger
}

/******************************
 main loop
*******************************/
void loop() {
  check_band();
  check_step_size();
 
  if (digitalRead(SSB_SWITCH)!=last_sideband) { 
    set_synth();
    display_freq_step();                          // display frequency & step-size
  }
 
  // check the frequency 
//  encoder = read_encoder();                       // returns +1/0/-1 (cw/nc/ccw)


  if (encoder != 0) {
    frequency = frequency + (encoder * step_size);
    
    set_synth();
    display_freq_step();                          // display frequency & step-size
    
    encoder=0;    // reset it
  } 
}

  
/******************************
 check frequency band
*******************************/
void check_band() {               // band now set from A6 reading

  temp = (analogRead(A6));
while ( temp !=(analogRead(A6)))
  {  temp = (analogRead(A6));}    // read until twice the same
                                  // convert reading to band number
if (temp <= 40)
  { temp = 0; 
  } 
  
if (temp >= 600)    
  { temp = 8; 
  }
  
if (temp >= 400)  
  { temp = 7; 
  }

if (temp >= 300)   
  { temp = 6; 
  }  

if (temp >= 160)    
  { temp = 5; 
  }

if (temp >= 100)    
  { temp = 4; 
  }

if (temp >= 80)    
  { temp = 3; 
  }

if (temp >= 60)    
  { temp = 2; 
  }
  
if (temp >= 50)     
  { temp = 1; 
  }

if (ham_band_index!=temp){    // update the band if it has changed
      ham_band_index=temp;
      
  long ham_band[] = {frequency0,frequency1,frequency2,frequency3,frequency4,frequency5,frequency6,frequency7,frequency8};
        frequency = ham_band[ham_band_index];     // change frequency band  
        set_synth ();                             // set the new frequ ****** added 20190502
        display_freq_step(); 
}
}

/******************************
 check the step size
*******************************/
void check_step_size() {
  // delay definitions
  #define DELAY 30                             // DELAY = debounce(mS)*loops/second
  #define LONG_PUSH 1500                        // number of loops considered "long"
  
  // variables
  static boolean transition = false;             // valid during button push
  static unsigned short integrator;              // varies from 0 to MAXIMUM
  static unsigned short push_duration;           // determines step size/direction
  
  // look for first high-to-low transition
  if (!transition && (digitalRead(ENCODER_BUTTON) == LOW)) {
    transition = true;
    integrator = 0;
    push_duration = 0;
  }
  
  // look for last low-to-high transition
  if (transition) {
    if (push_duration < (LONG_PUSH*2)) {         // track push duration
      push_duration++;
    }
    if (digitalRead(ENCODER_BUTTON) == HIGH) {   // ENCODER_BUTTON is HIGH
      if (integrator < DELAY) {        
        integrator++;
      } else {                                   // ENCODER_BUTTON is LOW
        if (integrator > 0) {
    integrator--;
  }
      }
    }
   
    // update the step_size
    if (integrator >= DELAY) { 
      transition = false;
      if (push_duration > LONG_PUSH) {          // LONG PUSH: decrease step size
        step_size = step_size/10;
        if (step_size < 10) {
          step_size = 100000;                   // wrap around    
        }        
      } else {                                  // SHORT PUSH: increase step size
        step_size = step_size*10;
        if (step_size > 100000) {
          step_size = 10;                       // wrap around
        }         
      }    
      display_freq_step();                            // update step-size     
    }
  }
}

/*******************************
set the Si5351 CLK0 frequency
 ******************************/

 void set_synth ()
{
  switch (ham_band_index)
   {       // limit to SSB part of bands  
      
    case 0:
    frequency = constrain(frequency, 0000000, 00000);   // out of band
    frequency0 = frequency;
    digitalWrite(BandF1,HIGH);
    digitalWrite(BandF2,HIGH);
    digitalWrite(BandF3,HIGH);
    digitalWrite(BandF4,HIGH);
    break;
  
    case 1:
    frequency = constrain(frequency, 1800000, 1875000);
    frequency1 = frequency;
    digitalWrite(BandF1,LOW);
    digitalWrite(BandF2,HIGH);
    digitalWrite(BandF3,HIGH);
    digitalWrite(BandF4,HIGH);
    break;
  
    case 2:
    frequency = constrain(frequency, 3500000, 3670000); 
    frequency2 = frequency;
    digitalWrite(BandF1,HIGH);
    digitalWrite(BandF2,LOW);
    digitalWrite(BandF3,HIGH);
    digitalWrite(BandF4,HIGH);
    break;

    case 3:
    frequency = constrain(frequency, 3600000, 3700000);
    frequency3 = frequency;
    digitalWrite(BandF1,HIGH);
    digitalWrite(BandF2,LOW);
    digitalWrite(BandF3,HIGH);
    digitalWrite(BandF4,HIGH);
    break;

    case 4:
    frequency = constrain(frequency, 7000000, 7300000);
    frequency4 = frequency;
    digitalWrite(BandF1,HIGH);
    digitalWrite(BandF2,HIGH);
    digitalWrite(BandF3,LOW);
    digitalWrite(BandF4,HIGH);
    break;
  
    case 5: 
    frequency = constrain(frequency, 10100000, 10150000);
    frequency7 = frequency;
    digitalWrite(BandF1,HIGH);
    digitalWrite(BandF2,HIGH);
    digitalWrite(BandF3,HIGH);
    digitalWrite(BandF4,LOW);
    break;

    case 6: 
    frequency = constrain(frequency, 14112000, 14350000);
    frequency8 = frequency;
    digitalWrite(BandF1,HIGH);
    digitalWrite(BandF2,HIGH);
    digitalWrite(BandF3,HIGH);
    digitalWrite(BandF4,LOW);
    break;

    case 7:
    frequency = constrain(frequency, 0000000, 00000);   // out of band
    frequency0 = frequency;
    digitalWrite(BandF1,HIGH);
    digitalWrite(BandF2,HIGH);
    digitalWrite(BandF3,HIGH);
    digitalWrite(BandF4,HIGH);
    break;

    case 8:
    frequency = constrain(frequency, 0000000, 00000);   // out of band
    frequency0 = frequency;
    digitalWrite(BandF1,HIGH);
    digitalWrite(BandF2,HIGH);
    digitalWrite(BandF3,HIGH);
    digitalWrite(BandF4,HIGH);
    break;
    
   }

 if (digitalRead(SSB_SWITCH)==HIGH)
    {
    clockgen.set_freq(USB, SI5351_CLK0); // USB
    last_sideband=1;
    }
  else
    {
    clockgen.set_freq(LSB, SI5351_CLK0); // LSB
    last_sideband=0;
    }

clockgen.set_freq(((frequency+offset)*100), SI5351_CLK1);
}

/********************************
 update frequency and step-size
********************************/
void display_freq_step() {
  long MHz = frequency/1000000;
   
  // convert frequency to floating point
  // adding 0.0000001 fixes a rounding error
  double freq = (double) frequency/1000000+0.0000001;

  // display frequency
      lcd.setCursor(0,0);
      if (digitalRead(SSB_SWITCH)==HIGH)
      { lcd.print("U");
      } 
      else 
      { lcd.print("L");
      }    

         // DEBUG - display ADC read of band switch  
          lcd.setCursor(11,1);
          temp=(analogRead(A6));
          if (temp <100){
            lcd.print(" ");
          }
            if (temp <10){
            lcd.print(" ");
          } 
          lcd.print(temp);
          lcd.setCursor(15,1);   
          lcd.print(ham_band_index);    

   lcd.setCursor(2,0);
 if (MHz < 10) {
    lcd.print(" ");
    } 
    lcd.print(freq, 6);
    lcd.print(" MHz ");
  
  // last digit always zero                      // digit sometimes showed a 1
  lcd.setCursor(10,0);
  lcd.print("0");

  // display step size

if (step_size != old_step_size)
  { old_step_size = step_size ;
  lcd.setCursor(5,1);
  lcd.print("     ");
  switch (step_size) {
    case 10:
      lcd.setCursor(9,1);
      lcd.print("*");       
      break;
    case 100:
      lcd.setCursor(8,1);
      lcd.print("*");       
      break;
    case 1000:
      lcd.setCursor(7,1);
      lcd.print("*");       
      break;
    case 10000:
      lcd.setCursor(6,1);
      lcd.print("*");       
      break;
    case 100000:
      lcd.setCursor(5,1);
      lcd.print("*");       
      break;
    default:
      break;
  }
  }

  // display the band in meters
      lcd.setCursor(0,1);
  switch (ham_band_index)
    { case 0:
      lcd.print("    ");
      break;
      case 1:
      lcd.print("160 ");
      break;
      case 2:
      lcd.print("80lo");
      break;
      case 3:
      lcd.print("80hi");
      break;
      case 4:
      lcd.print("  40");
      break;
      case 5:
      lcd.print("  30");
      break;
      case 6:
      lcd.print("  20");
      break;
      case 7:
      lcd.print("    ");
      break;
      case 8:
      lcd.print("    ");
      break;
   }  
}

void flag() {
  INTFLAG1 = 1;
  // add 1 to count for CW
  if (digitalRead(ENCODER_A) && !digitalRead(ENCODER_B)) {
  encoder ++;
  }
  // subtract 1 from count for CCW
  if (digitalRead(ENCODER_A) && digitalRead(ENCODER_B)) {
  encoder --;
  } 
}
